%Extracting GPS Data
%=================
%JFriedman
%Oct 10/13
%=================
clear all; close all; clc; tic;

%open file
namer = 'Garmin_ETREX_01';
fid = fopen([namer,'.txt'],'r');
token = 'N  New Track';

%make counters for line numbers
ii = 0; jj = 0;

%loop through finding start of tracks
while ~feof(fid)
    ii = ii + 1;
    stringer = fgets(fid);
    temp = strfind(stringer,token);
    if temp == 1
        jj = jj + 1;
        liner(jj,1) = ii;
    end
end
TOTAL = ii;

%read data into MATLAB
%find lines that SHOULD be read
frewind(fid);
all = [liner(1):TOTAL]';
LINES = setdiff(all,liner);

jj = 0;
kk = 1;
DATA = zeros(length(LINES),5);

%import data with following headers
% TRACK #, DATE, X, Y, ALT, DEPTH
for ii = 1:TOTAL
    stringer = fgets(fid);
    if sum(ii == LINES) > 0
        jj = jj + 1;
        DATA(jj,1) = kk;
        date = stringer(33:52); %get the date
        DATA(jj,2) = datenum(date, 'mmm dd HH:MM:SS yyyy');
        temp2 = strsplit(stringer,' ');
        DATA(jj,3) = str2double(temp2{3});
        DATA(jj,4) = str2double(temp2{4});
        temp3 = strsplit(stringer,';');
        DATA(jj,5) = str2double(temp3{2});
        DATA(jj,6) = str2double(temp3{3});
    else
        kk = kk + 1;
    end
end

DATA(:,1) = DATA(:,1) - DATA(1,1) + 1; %add the track number
save(namer,'DATA');

%export data for text (maybe needed?)
fid = fopen([namer,'_FORMATTED.txt'],'wt+');
fprintf(fid,'Track #, Date/Time, X (m, UTM35T), Y (m, UTM35T), ALT (m, from GPS)\n');
for ii = 1:length(DATA);
    fprintf(fid,'%d, %s, %.3f, %.3f, %.3f\n',DATA(ii,1),datestr(DATA(ii,2),'yyyy/mm/dd HH:MM:SS'),DATA(ii,3),DATA(ii,4),DATA(ii,5));
end
fclose(fid);

toc;

